package com.vcarecity.cvs.core;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * @author Kerry on 19/11/29
 */

public class ColumnUpdateMapper {


    @AllArgsConstructor
    @NoArgsConstructor
    @Data
    private static class ColumnMapper {
        private String origin;
        private String update;
    }

    private static List<ColumnMapper> manualMapper;

    private static List<String> MYSQL_KEY_WORD;

    static {
        manualMapper = new ArrayList<>();
        manualMapper.add(new ColumnMapper("POSITION", "POSITIONS"));


        Set<String> keyWord = new HashSet<>();
        keyWord.add("POSITION");

        MYSQL_KEY_WORD = new ArrayList<>(keyWord);
    }


    /**
     * Oracle数据库的字段可能跟 MySQL 不一样,统一这里处理
     *
     * @param table
     * @param headers
     * @return
     */
    public static String[] updateColumnName(String table, String[] headers) {
        // common mapper
        for (int i = 0; i < headers.length; i++) {
            final String h = headers[i].toUpperCase();
            for (ColumnMapper columnMapper : manualMapper) {
                if (columnMapper.getOrigin().equalsIgnoreCase(h)) {
                    headers[i] = columnMapper.getUpdate();
                    break;
                }
            }
        }

        // 关键字先处理下
        for (int i = 0; i < headers.length; i++) {
            final String h = headers[i].toUpperCase();
            for (String s : MYSQL_KEY_WORD) {
                if (s.equalsIgnoreCase(h)) {
                    headers[i] = "`" + headers[i] + "`";
                    break;
                }
            }
        }

        return headers;
    }

}
