package com.vcarecity.cvs.script;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Random;

/**
 * @author Kerry on 19/11/21
 */

public class DataBuilder {

    public static void main(String[] args) throws IOException {
        DataBuilder builder = new DataBuilder();
        builder.builder();
    }

    public void builder() throws IOException {
        int count = 1000000;
        dateTime = LocalDateTime.of(2018, 1, 1, 0, 0, 0);

        String[] header = {
                "CHECK_RECORD_ID",
                "STAMP",
                "USER_ID",
                "CHECK_POINTS_ID",
                "IS_NORMAL",
                "IS_LATENT_DANGER",
                "LATENT_DANGER_TYPE",
                "LATENT_DANGER_DESC",
                "UNDETECTED_NUM",
                "LON",
                "LAT",
                "RULE_ID",
                "IS_DEAL",
                "STARTDATE",
                "ENDDATE",
                "VALID_CHECK",
                "UPDATESTAMP"
        };


    }

    public static final String NULL_VALUE = "\\N";

    private final int min_user_id = 2000;
    private Random random = new Random();
    private long recordId = 1;
    private LocalDateTime dateTime;
    private int userId = min_user_id;


    private String[] getContent(int index, int col) {
        index++;
        String[] line = new String[col];
        line[0] = "" + (recordId++);
        if (index % 1500 == 0) {
            dateTime = dateTime.plusDays(1L);
        }
        line[1] = formatDateTime(dateTime);
        line[2] = getUserId();
        line[3] = getUserId();
        line[4] = String.valueOf(random.nextInt(10));
        line[5] = String.valueOf(random.nextInt(10));
        line[6] = String.valueOf(random.nextInt(10));

        line[7] = getMessage();

        line[8] = String.valueOf(random.nextInt(55555));
        line[9] = "" + Math.random() * 100;
        line[10] = "" + Math.random() * 100;
        line[11] = String.valueOf(random.nextInt(100000));
        line[12] = String.valueOf(random.nextInt(12));
        line[13] = null;
        line[14] = null;
        line[15] = String.valueOf(random.nextInt(12));
        line[16] = formatDateTime(dateTime);

        for (int i = 0; i < line.length; i++) {
            if (line[i] == null) {
                line[i] = NULL_VALUE;
            }
        }

        return line;
    }

    private String getUserId() {
        int max_user_id = 20000;
        if (userId > max_user_id) {
            userId = min_user_id;
        }
        return String.valueOf(userId++);
    }

    public static final DateTimeFormatter FORMATTER = DateTimeFormatter.ofPattern("yyyy/MM/dd HH:mm:ss");

    private static String formatDateTime(LocalDateTime localDateTime) {
        return localDateTime.format(FORMATTER);
    }

    public String getMessage() {
        final int i = random.nextInt(60);
        StringBuffer sb = new StringBuffer();
        for (int j = 0; j < i; j++) {
            sb.append(getRandomChar());
        }
        return sb.toString();
    }

    public static String getRandomChar() {
        String str = "";
        int highCode;
        int lowCode;

        Random random = new Random();
        //B0 + 0~39(16~55) 一级汉字所占区
        highCode = (176 + Math.abs(random.nextInt(39)));
        //A1 + 0~93 每区有94个汉字
        lowCode = (161 + Math.abs(random.nextInt(93)));

        byte[] b = new byte[2];
        b[0] = (Integer.valueOf(highCode)).byteValue();
        b[1] = (Integer.valueOf(lowCode)).byteValue();

        try {
            str = new String(b, "GBK");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return str;
    }

}
